import 'package:example/buttons_view.dart';
import 'package:flutter/material.dart';
import 'package:hx_components_flutter/hx_components.dart';
import 'package:hx_components_flutter/hx_models.dart';

class ExampleView extends StatefulWidget {
  const ExampleView({super.key});

  @override
  State<ExampleView> createState() => _ExampleViewState();
}

class _ExampleViewState extends State<ExampleView> {
  final textController1 = TextEditingController();
  final textController2 = TextEditingController();
  final textController3 = TextEditingController();
  dynamic _groupValue = 4;

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: SingleChildScrollView(
        child: Padding(
          padding: const EdgeInsets.all(8.0),
          child: Wrap(
            spacing: 10,
            runSpacing: 10,
            runAlignment: WrapAlignment.start,
            alignment: WrapAlignment.start,
            children: [
              const HxCurvedAppBar.login(),
              const HxCurvedAppBar.menu(terminal: 'T15', user: 'Roberto'),
              const HxDeveloperStatusAppVersion(
                version: '1.0.0',
                apisWidget: Text('APIs'),
                ambiente: 'DEV',
                corAmbiente: Colors.red,
                corTexto: Colors.red,
              ),
              const HxDeveloperStatusAppVersion(
                version: '1.0.0',
                apisWidget: Text('APIs'),
                ambiente: 'QA',
                corAmbiente: Colors.green,
                corTexto: Colors.green,
              ),
              const HxDeveloperStatusAppVersion(
                version: '1.0.0',
                apisWidget: Text('APIs'),
                ambiente: 'PROD',
                corAmbiente: Colors.blue,
                corTexto: Colors.blue,
              ),
              HxText.heading1('Heading 1'),
              HxText.heading1('Heading 1', fontWeight: FontWeight.normal),
              HxText.heading2('Heading 2'),
              HxText.heading2('Heading 2', fontWeight: FontWeight.normal),
              HxText.heading3('Heading 3'),
              HxText.heading3('Heading 3', fontWeight: FontWeight.normal),
              HxText.heading4('Heading 4'),
              HxText.heading4('Heading 4', fontWeight: FontWeight.normal),
              HxText('Body'),
              Row(
                children: [
                  HxButton.primary(
                      title: 'Toast Sucesso',
                      onTap: () {
                        HxToast.sucesso(context, 'Ação realizada com sucesso!');
                      }),
                  const SizedBox(width: 5.0),
                  HxButton.secondary(
                      title: 'Toast Erro',
                      onTap: () {
                        HxToast.erro(context, 'Tivemos problemas na sua requisição. Por favor tente novamente.');
                      }),
                  const SizedBox(width: 5.0),
                ],
              ),
              Row(
                children: [
                  HxButton.primary(
                      title: 'Alert Dialog',
                      onTap: () {
                        showDialog(
                          context: context,
                          builder: (context) {
                            return const HxAlertDialog(
                              titulo: 'Confirmar',
                              mensagem: 'Deseja realmente confirmar esta ação?',
                              textoBotaoConfirmar: 'Confirmar',
                              textoBotaoCancelar: 'Cancelar',
                            );
                          },
                        );
                      }),
                ],
              ),
              Row(
                children: [
                  HxButton.primary(
                      title: 'HxButton',
                      onTap: () {
                        Navigator.of(context).push(MaterialPageRoute(builder: (context) => const ButtonsView()));
                      }),
                  const SizedBox(width: 5.0),
                  HxButton.secondary(title: 'HxButton', onTap: () {}, prefixIcon: Icons.check),
                  const SizedBox(width: 5.0),
                  HxButton.primary(title: 'HxButton', onTap: () {}, prefixIcon: Icons.check, isLoading: true),
                ],
              ),
              const SizedBox(height: 5.0),
              Row(
                children: [
                  HxButton.primary(
                    title: 'HxButton',
                    onTap: () {},
                  ),
                  const SizedBox(width: 5.0),
                  HxButton.secondary(title: 'HxButton', prefixIcon: Icons.check),
                  const SizedBox(width: 5.0),
                  HxButton.secondary(title: 'HxButton', prefixIcon: Icons.check, isLoading: true),
                ],
              ),
              const Divider(),
              const SizedBox(height: 5.0),
              Row(
                children: [
                  HxButton.secondary(title: 'HxButton', onTap: () {}, densidade: VisualDensity.compact),
                  const SizedBox(width: 5.0),
                  HxButton.primary(title: 'HxButton', onTap: () {}, prefixIcon: Icons.check, densidade: VisualDensity.compact),
                  const SizedBox(width: 5.0),
                  HxButton.secondary(title: 'HxButton', onTap: () {}, prefixIcon: Icons.check, isLoading: true, densidade: VisualDensity.compact),
                ],
              ),
              const SizedBox(height: 5.0),
              Row(
                children: [
                  HxButton.secondary(
                    title: 'HxButton',
                    densidade: VisualDensity.compact,
                  ),
                  const SizedBox(width: 5.0),
                  HxButton.primary(
                    title: 'HxButton',
                    prefixIcon: Icons.check,
                    densidade: VisualDensity.compact,
                    onTap: () {
                      print('tap');
                    },
                  ),
                  const SizedBox(width: 5.0),
                  HxButton.primary(
                    title: 'HxButton',
                    prefixIcon: Icons.check,
                    densidade: VisualDensity.compact,
                    isLoading: true,
                    onTap: () {
                      print('tap');
                    },
                  ),
                ],
              ),
              const SizedBox(height: 5.0),
              const Divider(),
              Row(
                children: [
                  HxButton.primaryIcon(prefixIcon: Icons.add_box, onTap: () {}),
                  HxButton.secondaryIcon(prefixIcon: Icons.add_box, onTap: () {}),
                  HxOutlineButton.icon(
                    prefixIcon: Icons.add_box,
                    onTap: () {},
                  ),
                  HxOutlineButton.icon(
                    onTap: () {},
                    prefixIcon: Icons.add_box,
                    densidade: VisualDensity.compact,
                  ),
                ],
              ),
              const Divider(),
              Row(
                children: [
                  HxOutlineButton(title: 'Outline', onTap: () {}, prefixIcon: Icons.outbond_outlined),
                  const SizedBox(width: 5.0),
                  HxOutlineButton(title: 'Outline', onTap: () {}),
                  const SizedBox(width: 5.0),
                  HxOutlineButton(title: 'Outline', onTap: () {}, isLoading: true),
                ],
              ),
              const SizedBox(height: 5.0),
              Row(
                children: [
                  HxOutlineButton(
                    title: 'Outline',
                    onTap: () {},
                    prefixIcon: Icons.outbond_outlined,
                    densidade: VisualDensity.compact,
                  ),
                  const SizedBox(width: 5.0),
                  HxOutlineButton(
                    title: 'Outline',
                    onTap: () {},
                    densidade: VisualDensity.compact,
                  ),
                  const SizedBox(width: 5.0),
                  HxOutlineButton(
                    title: 'Outline',
                    onTap: () {},
                    isLoading: true,
                    densidade: VisualDensity.compact,
                  ),
                ],
              ),
              const SizedBox(height: 5.0),
              const Divider(),
              HxButton.primary(
                title: 'HxButton ',
                onTap: () {},
                width: double.maxFinite,
              ),
              const SizedBox(height: 5.0),
              HxButton.primary(
                title: 'HxButton ',
                onTap: () {},
                isLoading: true,
                width: double.maxFinite,
              ),
              const SizedBox(height: 5.0),
              HxButton.secondary(
                prefixIcon: Icons.person,
                onTap: () {},
                width: double.maxFinite,
              ),
              const SizedBox(height: 5.0),
              HxButton.secondary(
                prefixIcon: Icons.person,
                onTap: () {},
                width: double.maxFinite,
                densidade: VisualDensity.compact,
              ),
              const SizedBox(height: 5.0),
              HxOutlineButton(title: 'HxButton ', prefixIcon: Icons.person, onTap: () {}, width: double.maxFinite),
              const SizedBox(height: 5.0),
              HxButton.secondary(
                title: 'HxButton ',
                width: double.maxFinite,
              ),
              Row(
                children: <Widget>[
                  HxCardButton(
                    homeNavigation: () {},
                    text: HxText.heading3('Heading 3', fontWeight: FontWeight.normal),
                    icon: Icons.person,
                  ),
                  HxCardButton(
                    homeNavigation: () {},
                    text: HxText.heading3('Heading 3', fontWeight: FontWeight.normal),
                    icon: Icons.warning,
                  ),
                ],
              ),
              HxListItem.white(
                title: 'Heading 2',
                onTap: () {},
                icon: Icons.back_hand,
              ),
              HxListItem.white(
                title: 'Heading 2',
                onTap: () {},
                loading: true,
                icon: Icons.back_hand,
              ),
              HxListItem.white(
                title: 'Heading 2',
                onTap: () {},
                enabled: false,
                icon: Icons.back_hand,
              ),
              HxListItem.white(
                title: 'Heading 2',
                onTap: () {},
                loading: true,
                enabled: false,
                icon: Icons.back_hand,
              ),
              HxListItem.blue(
                title: 'Heading 2',
                onTap: () {},
                icon: Icons.cached,
              ),
              HxListItem.white(
                title: 'Heading 2',
                description: 'Body',
                onTap: () {},
                icon: Icons.dark_mode,
              ),
              const SizedBox(height: 5.0),
              HxListItem.blue(
                title: 'Heading 2',
                description: 'Body',
                onTap: () {},
                icon: Icons.arrow_forward_ios,
              ),
              Row(
                children: [
                  HxCheckbox.light(
                    value: true,
                    label: 'Body',
                  ),
                  HxCheckbox.light(
                    value: false,
                    label: 'HxCheckbox',
                  ),
                ],
              ),
              Row(
                children: [
                  HxCheckbox.dark(
                    value: false,
                    label: 'Body',
                  ),
                  HxCheckbox.dark(
                    value: true,
                    label: 'HxCheckbox',
                  ),
                ],
              ),
              Row(
                children: [
                  HxRadioButton.light(
                    label: 'Radio1',
                    value: 1,
                    groupValue: _groupValue,
                    onChanged: _handleRadioValueChange,
                  ),
                  HxRadioButton.light(
                    label: 'Radio2',
                    toggleable: false,
                    value: 2,
                    groupValue: _groupValue,
                    onChanged: _handleRadioValueChange,
                  ),
                ],
              ),
              Row(
                children: [
                  HxRadioButton.dark(
                    label: 'Radio3',
                    value: 3,
                    groupValue: _groupValue,
                    onChanged: _handleRadioValueChange,
                  ),
                  HxRadioButton.dark(
                    label: 'Radio4',
                    value: 4,
                    groupValue: _groupValue,
                    onChanged: _handleRadioValueChange,
                  ),
                ],
              ),
              Row(
                children: <Widget>[
                  const HxChip(title: 'Body'),
                  HxChip(
                    title: 'OnTap - HxChip',
                    onTap: () {},
                  ),
                  const HxChip(title: 'HexagonProLib'),
                ],
              ),
              HxTextInput(
                controller: textController1,
                label: 'HxTextInput',
                textMask: "##########",
              ),
              HxTextInput.typed(
                controller: textController2,
                label: 'HxTextInput - Email',
                textFieldType: TextFieldType.email,
                initialValue: 'HxEmail@hexagon.pro',
              ),
              HxTextInput.typed(
                controller: textController3,
                label: 'HxTextInput - Password',
                textFieldType: TextFieldType.password,
                initialValue: 'Hx1234',
                isLoading: true,
              ),
              HxDropdownSearch<String>(
                items: const [
                  'Brazil',
                  'Italia',
                  'Tunisia',
                  'Canada',
                  'USA',
                ],
                label: 'Teste Normal',
                onChanged: (p0) {
                  debugPrint(p0);
                },
                isLoading: true,
              ),
              HxMultiDropdownSearch<int>(items: const [
                1,
                2,
                3,
                4,
                5
              ], onChanged: (p0) {}, label: 'MultiSelect Dropdown'),
              HxDropdownSearch<String>.async(
                label: 'Teste Async',
                onChanged: (p0) {
                  debugPrint(p0);
                },
                asyncItems: (p0) async {
                  return [];
                },
                emptyBuilder: (p0, p1) {
                  return Padding(
                    padding: const EdgeInsets.all(20.0),
                    child: Row(
                      mainAxisAlignment: MainAxisAlignment.center,
                      children: [
                        HxText('Empty'),
                      ],
                    ),
                  );
                },
              ),
              const HxTimePickerInput(label: 'Time Picker', modalDatePickerTitle: "Tempo teste", prefixIcon: Icons.watch),
              const HxDatePickerInput(label: 'Date Picker', modalDatePickerTitle: "Data teste", prefixIcon: Icons.calendar_month),
              const HxGradientBg(height: 200),
              const HxAnimatedBg(height: 200),
            ],
          ),
        ),
      ),
    );
  }

  void _handleRadioValueChange(value) {
    setState(() {
      _groupValue = value;
    });
  }
}
