import 'package:flutter/material.dart';
import 'package:hx_components_flutter/hx_components.dart';
import 'package:hx_components_flutter/hx_utils.dart';
import 'package:intl/intl.dart';

class HxDatePickerInput extends StatefulWidget {
  const HxDatePickerInput({super.key, required this.label, required this.modalDatePickerTitle, this.prefixIcon, this.initialValue, this.isLoading, this.onChangedInputFunction, this.onFieldSubmitted, this.errorText});
  final String label;
  final String modalDatePickerTitle;
  final IconData? prefixIcon;
  final String? initialValue;
  final bool? isLoading;
  final dynamic Function(String)? onChangedInputFunction;
  final dynamic Function(String)? onFieldSubmitted;
  final String? errorText;
  @override
  State<HxDatePickerInput> createState() => _HxDatePickerInputState();
}

class _HxDatePickerInputState extends State<HxDatePickerInput> {
  DateTime dtaseleciona = DateTime.now();
  TextEditingController controller = TextEditingController();
  FocusNode focus = FocusNode();
  bool readonly = false;

  @override
  Widget build(BuildContext context) {
    return HxTextInput(
      initialValue: widget.initialValue,
      isLoading: widget.isLoading,
      onChangedInputFunction: widget.onChangedInputFunction,
      onFieldSubmitted: widget.onFieldSubmitted,
      errorText: widget.errorText,
      readonly: readonly,
      label: widget.label,
      icon: widget.prefixIcon,
      controller: controller,
      focusNode: focus,
      onTap: () async {
        final DateTime? picked = await showDatePicker(
          builder: (context, child) => Theme(
            data: Theme.of(context).copyWith(colorScheme: ColorScheme.light(primary: kcPrimaryColor)),
            child: child!,
          ),
          context: context,
          initialDate: DateTime.now(),
          helpText: widget.modalDatePickerTitle,
          cancelText: "Cancelar",
          confirmText: "Confirmar",
          firstDate: DateTime(2015, 8),
          lastDate: DateTime(2101),
        );
        if (picked != null) {
          setState(() {
            dtaseleciona = picked;
            controller.text = DateFormat('dd/MM/yyyy').format(dtaseleciona);
            focus.unfocus();
            readonly = true;
          });
        }
      },
    );
  }
}
