import 'package:flutter/material.dart';
import 'package:hx_components_flutter/src/widgets/hx_text_input.dart';

class HxTimePickerInput extends StatefulWidget {
  const HxTimePickerInput({super.key, required this.label, required this.modalDatePickerTitle, this.prefixIcon, this.initialValue, this.isLoading, this.onChangedInputFunction, this.onFieldSubmitted, this.errorText});
  final String label;
  final String modalDatePickerTitle;
  final IconData? prefixIcon;
  final String? initialValue;
  final bool? isLoading;
  final dynamic Function(String)? onChangedInputFunction;
  final dynamic Function(String)? onFieldSubmitted;
  final String? errorText;
  @override
  State<HxTimePickerInput> createState() => _HxTimePickerInputState();
}

class _HxTimePickerInputState extends State<HxTimePickerInput> {
  TimeOfDay timeseleciona = TimeOfDay.now();
  TextEditingController controller = TextEditingController();
  FocusNode focus = FocusNode();
  bool readonly = false;

  @override
  Widget build(BuildContext context) {
    return HxTextInput(
      initialValue: widget.initialValue,
      isLoading: widget.isLoading,
      onChangedInputFunction: widget.onChangedInputFunction,
      onFieldSubmitted: widget.onFieldSubmitted,
      errorText: widget.errorText,
      readonly: readonly,
      label: widget.label,
      icon: widget.prefixIcon,
      controller: controller,
      focusNode: focus,
      onTap: () async {
        final picked = await showTimePicker(
          initialTime: TimeOfDay.now(),
          context: context,
        );
        if (picked != null) {
          setState(() {
            timeseleciona = picked;
            controller.text = timeseleciona.format(context);
            focus.unfocus();
            readonly = true;
          });
        }
      },
    );
  }
}
