import 'package:flutter/material.dart';
import 'package:hx_components_flutter/hx_components.dart';
import 'package:hx_components_flutter/hx_utils.dart';

class HxConnectionErrorBuilder extends StatelessWidget {
  const HxConnectionErrorBuilder({super.key, required this.wifiIconOnTapRedirect});

  final Widget? wifiIconOnTapRedirect;

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      backgroundColor: kcBackgroundColor,
      body: Center(
        child: Padding(
          padding: const EdgeInsets.symmetric(vertical: 20),
          child: Column(
            mainAxisAlignment: MainAxisAlignment.end,
            children: [
              Column(
                mainAxisAlignment: MainAxisAlignment.center,
                children: [
                  InkWell(
                    onTap: wifiIconOnTapRedirect == null
                        ? () => Navigator.push(
                              context,
                              MaterialPageRoute(builder: (context) => wifiIconOnTapRedirect!),
                            )
                        : () {},
                    child: const Icon(
                      Icons.wifi_off,
                      color: kcError,
                      size: 150,
                    ),
                  ),
                  HxText.heading2('Erro de conexão! '),
                  const Padding(
                    padding: EdgeInsets.all(16),
                    child: Text(
                      'Verifique se o dispositivo está conectado na internet e reinicie o aplicativo.',
                      style: TextStyle(color: kcDarkGrey),
                      textAlign: TextAlign.center,
                    ),
                  ),
                  SizedBox(height: MediaQuery.of(context).size.height * 0.25),
                ],
              ),
              Center(
                child: Image.asset(
                  'assets/images/logo.png',
                  color: kcDarkGrey,
                  height: 40,
                  width: 200,
                ),
              ),
            ],
          ),
        ),
      ),
    );
  }
}
