import 'package:flutter/material.dart';
import 'package:hx_components_flutter/hx_components.dart';
import 'package:hx_components_flutter/hx_utils.dart';

class HxErrorScreenBuilder extends StatelessWidget {
  const HxErrorScreenBuilder({super.key, this.details});

  final FlutterErrorDetails? details;

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      backgroundColor: kcBackgroundColor,
      body: Center(
        child: Padding(
          padding: const EdgeInsets.symmetric(vertical: 20),
          child: Column(
            mainAxisAlignment: MainAxisAlignment.spaceBetween,
            children: [
              Column(
                children: [
                  const Icon(
                    Icons.warning,
                    color: kcError,
                    size: 150,
                  ),
                  HxText.heading2('Algo deu errado! '),
                  const Padding(
                    padding: EdgeInsets.all(16),
                    child: SizedBox(
                      width: 180,
                      child: Flexible(
                        child: Text(
                          'Reinicie o aplicativo ou contate nosso suporte se o erro persistir.',
                          style: TextStyle(color: kcDarkGrey),
                          textAlign: TextAlign.center,
                        ),
                      ),
                    ),
                  ),
                  Container(
                    height: MediaQuery.of(context).size.height * 0.4,
                    padding: EdgeInsets.symmetric(horizontal: details == null ? 0 : 30),
                    child: SingleChildScrollView(
                      child: Text(
                        '${details ?? ''}',
                        style: const TextStyle(color: kcError),
                        softWrap: true,
                      ),
                    ),
                  ),
                ],
              ),
              Center(
                child: Image.asset(
                  'assets/images/logo.png',
                  color: kcDarkGrey,
                  height: 40,
                  width: 200,
                ),
              ),
            ],
          ),
        ),
      ),
    );
  }
}
